Program Palindrom_maxim;

Const INFILE = 'palin.in';
      OUTFILE = 'palin.out';

Var Cifre: Array[0..9] Of Integer;
    f, g: Text;
    n: LongInt;

Procedure Citire;
Begin
  Assign(f, INFILE); Reset(f);
  ReadLn(f, n);
  Close(f);
End;

Procedure Descompune;
Begin          {contorizez numarul de aparitii a cifrelor in vectorul Cifre[]}
  Repeat                          {fac cu REPEAT}
    Inc(Cifre[n MOD 10]);         {ca sa prind si cazul n=0}
    n := n DIV 10
  Until n = 0
End;

Function Se_Poate: Boolean;
Var Cate_Impare, i: Byte;
Begin                            {verific numarul de aparitii a cifrelor}
  Se_Poate := TRUE;              {maxim una poate sa apara de un numar impar}
  Cate_Impare := 0;              {de ori}
  For i := 0 To 9 Do
    If Cifre[i] MOD 2 = 1 Then
      Inc(Cate_Impare);
  If Cate_Impare>1 Then
    Se_Poate := FALSE;
End;

Function Exista_Alte_Pare: Boolean;
Var i: Byte;
Begin
  Exista_Alte_Pare := FALSE;
  For i := 1 To 9 Do
    If (Cifre[i]>0) AND (Cifre[i] MOD 2 = 0) Then
      Exista_Alte_Pare := TRUE;
End;

Procedure Afiseaza;
Var i, j: Byte;
    Care_Este_Impar: Integer;
Begin
  Care_Este_Impar := -1;          {nu are impare}
  For i := 0 To 9 Do
    If Cifre[i] MOD 2 = 1 Then
      Care_Este_Impar := i;       {acesta este in numar impar}
  If (Care_Este_Impar >= 0) AND   {daca am impar si}
     (Cifre[0] MOD 2 = 0) AND     {acesta nu este 0 si}
     (Cifre[Care_Este_Impar] = 1) AND  {apare o data si}
     NOT Exista_Alte_Pare Then    {nu exista alte cifre decat cifra 0}
        WriteLn(g, -1)            {nu se poate - este de tipul ... 400}
  Else
    Begin
      For i := 9 DownTo 0 Do      {afisez descrescator jumatate din ele}
        For j := 1 To Cifre[i] DIV 2 Do
          Write(g, i);
      If Care_Este_Impar >= 0 Then{afisez cel care apare de impar ori}
        Write(g, Care_Este_Impar);
      For i := 0 To 9 Do          {afisez crescator cealalta jumatate}
        For j := 1 To Cifre[i] DIV 2 Do
          Write(g, i);
      WriteLn(g)
    End;
End;

Begin
  Citire;
  Assign(g, OUTFILE); ReWrite(g);
  If n<10 Then
    WriteLn(g, n){caz particular, orice numar dintr-o cifra este palindrom}
  Else
    Begin
      Descompune;
      If Se_Poate Then
        Afiseaza
      Else
        WriteLn(g, -1);
    End;
  Close(g)
End.
