{$M 65520,0,655360}

Program Ship;
Const MAX = 800;
      DIM = 200;

Type Huge=Array[0..DIM] Of ShortInt;

Var L1, L2: Array[0..MAX+1] Of Huge; {cele doua linii consecutive din tr. Pascal}
    K: Huge;
    s, n: Integer;
    Fin, Fout: Text;

Procedure Citire;
Begin
  Assign(Fin, 'ship.in'); Reset(Fin);
  ReadLn(Fin, s, n);
  Close(Fin)
End;

Procedure WriteHuge(X: Huge);
Var i: Integer;
Begin
  For i := X[0] DownTo 1 Do
     Write(Fout, X[i]);
  WriteLn(Fout);
End;

Procedure Atrib0(Var H: Huge);
Begin
  H[0] := 0;
End;

Procedure AtribValue(Var H: Huge; X: LongInt);
Begin
  H[0] := 0;
  While (X<>0) Do
    Begin
      Inc(H[0]);
      H[H[0]] := X Mod 10;
      X := X Div 10;
    End
End;

Procedure AtribHuge(Var H: Huge; X: Huge);
Var i: Integer;
Begin
  H := X;   {  For i := 0 To X[0] Do H[i] := X[i];}
End;

Procedure Add(A, B: Huge; Var C: Huge);
Var i, T: Integer;
Begin           {A+B-->C}
  T := 0;
  If (B[0]>A[0]) Then
    Begin
      For i := A[0]+1 To B[0] Do A[i] := 0;
      A[0] := B[0];
    End
  Else
    For i := B[0]+1 To A[0] Do B[i] := 0;
  C[0] := A[0];
  For i := 1 To A[0] Do
    Begin
      C[i] := A[i]+B[i]+T;
      T := C[i] Div 10;
      C[i] := C[i] Mod 10;
    End;
  If T=1 Then
    Begin
      Inc(C[0]);
      C[C[0]] := T
    End
End;

Procedure Subtract(A, B: Huge; Var C: Huge);
Var i, j, T: Integer;        {A-B-->C, cu A>=B}
    X: Huge;
Begin
  T := 0;
  For i := B[0]+1 To A[0] Do B[i] := 0;
  For i := 1 To A[0] Do
    Begin  {   A[i]+=(T=(A[i]-=B[i]+T)<0)?10:0;   }
      If A[i]>=B[i] Then
        A[i] := A[i]-B[i]
      Else
        Begin
          j := i+1;                 {plec de la cifra urmatoare}
          While A[j]=0 Do j := j+1; {o caut pe prima nenula}
          A[j] := A[j]-1;           {scad 1 din ea}
          j := j-1;                 {vin inapoi si}
          While j>i Do              {peste tot unde a fost 0}
            Begin
              A[j] := 9;            {pun 9}
              j := j-1
            End;
          A[i] := A[i] + 10 - B[i]; {adun 10 la A[i] si acum pot sa scad B[i]}
        End;
    End;
  While (A[A[0]]=0) Do A[0] := A[0]-1; {verific daca am cifre 0 nesemnificative}
  If A[0]<0 Then A[0] := 0; {la scadere am obtinut chiar 0}
  For i := 0 To DIM Do C[i] := A[i];
End;

Procedure Subtract1(Var A: Huge; B: Huge);
Var i, j, T: Integer;         {A-B-->A}
Begin
  T := 0;
  For i := B[0]+1 To A[0] Do B[i] := 0;
  For i := 1 To A[0] Do
    Begin  {   A[i]+=(T=(A[i]-=B[i]+T)<0)?10:0;   }
      If A[i]>=B[i] Then
        A[i] := A[i]-B[i]
      Else
        Begin
          j := i+1;                 {plec de la cifra urmatoare}
          While A[j]=0 Do j := j+1; {o caut pe prima nenula}
          A[j] := A[j]-1;           {scad 1 din ea}
          j := j-1;                 {vin inapoi si}
          While j>i Do              {peste tot unde a fost 0}
            Begin
              A[j] := 9;            {pun 9}
              j := j-1
            End;
          A[i] := A[i] + 10 - B[i]; {adun 10 la A[i] si acum pot sa scad B[i]}
        End;
    End;
  While (A[A[0]]=0) Do A[0] := A[0]-1; {verific daca am cifre 0 nesemnificative}
  If A[0]<0 Then A[0] := 0;         {la scadere am obtinut chiar 0}
End;

Procedure ShiftLeft(Var H: Huge; Count: Integer);
Var i: Integer;
Begin
  For i := H[0] DownTo 1 Do
    H[i+Count] := H[i];
  For i := 1 To Count Do H[i] := 0;
  H[0] := H[0] + Count;
End;

Procedure ShiftR(Var H: Huge; Count: Integer);
Var i: Integer;
Begin
  For i := Count+1 To H[0] Do H[i-Count] := H[i];
  H[0] := H[0] - Count;
End;

Function Sgn(H1, H2: Huge): Integer;
Var i: Integer;
Begin
  While (H1[H1[0]]=0) And (H1[0]>0) Do Dec(H1[0]);
  While (H2[H2[0]]=0) And (H2[0]>0) Do Dec(H2[0]);
  If H1[0]<>H2[0] Then
    If H1[0]<H2[0] Then Sgn := -1 Else Sgn := 1
  Else
    Begin
      i := H1[0];
      While (H1[i]=H2[i]) And (i>0) Do Dec(i);
      If H1[i]<H2[i] Then Sgn := -1
      Else
        If H1[i]=H2[i] Then Sgn := 0 Else Sgn := 1;
    End
End;

Procedure Pascal;
Var i, j: Integer;
Begin
  For i := 0 To MAX Do
    Begin
      Atrib0(L1[i]);
      Atrib0(L2[i]);
    End;
  AtribValue(L1[1], 1);
  For i := 1 To s*(n+1) Do
    Begin
      For j := 1 To i+1 Do Add(L1[j-1], L1[j], L2[j]);
      For j := 1 To i+1 Do AtribHuge(L1[j], L2[j]);
    End
End;

Procedure MultHuge(A, B: Huge; Var C: Huge);
Var i, j, T: Integer;         {A*B-->C}
Begin
  T := 0;
  C[0] := A[0]+B[0]-1;
  For i := 1 To A[0]+B[0] Do C[i] := 0;
  For i := 1 To A[0] Do
    For j := 1 To B[0] Do
      C[i+j-1] := C[i+j-1]+A[i]*B[j];
  For i := 1 To C[0] Do
    Begin
      C[i] := C[i]+T;
      T := C[i] Div 10;
      C[i] := C[i] Mod 10;
    End;
  If T<>0 Then
    Begin
      Inc(C[0]);
      C[C[0]] := T
    End
End;

Procedure Add1(Var A: Huge; B: Huge);
Var i, T: Integer;   {A+B-->A}
    C: Huge;
Begin
  T := 0;
  For i := 0 To DIM Do C[i] := 0;
  If B[0]>A[0] Then
    Begin
      For i := A[0]+1 To B[0] Do A[i] := 0;
      A[0] := B[0];
    End
  Else
    For i := B[0]+1 To A[0] Do B[i] := 0;
  C[0] := A[0];
  For i := 1 To A[0] Do
    Begin
      C[i] := A[i]+B[i]+T;
      T := C[i] Div 10;
      C[i] := C[i] Mod 10;
    End;
  If T<>0 Then
    Begin
      Inc(C[0]);
      C[C[0]] := T
    End;
  For i := 0 To DIM Do A[i] := C[i];
End;

Procedure DivideHuge(A, B: Huge; Var C, R: Huge);
Var i: Integer;
    Aux: Huge;
Begin
  R[0] := 0; C[0] := A[0];
  For i := A[0] DownTo 1 Do
    Begin
      ShiftLeft(R, 1); R[1] := A[i];
      C[i] := 0;
      While Sgn(B, R)<>1 Do
        Begin
          Inc(C[i]);
          Subtract1(R, B);
        End
    End;
  While (C[C[0]]=0) And (C[0]>1) Do Dec(C[0]);
End;

Procedure DivideHuge1(A, B: Huge; Var C, R: Huge);
Var i: Integer;
    Unu, Aux: Huge;
Begin
  For i := 0 To DIM Do
    Begin
       Unu[i] := 0;
       C[i] := 0;
       Aux[i] := 0;
    End;
  For i := 0 To A[0]+1 Do R[i] := A[i];
  Unu[0] := 1; Unu[1] := 1; C[0] := 0;
  While Sgn(R, B)>0 Do
    Begin
      Subtract(R, B, Aux);
      Add1(C, Unu);
      AtribHuge(R, Aux);
    End;
  If Sgn(R, B)=0 Then
    Begin
      Add1(C, Unu);
      Atrib0(R);
    End
End;

Procedure Calcul;
Var numitor: Huge;
    s_1, N1, X, R: Huge;
Begin
  AtribValue(s_1, s-1);
  AtribValue(N1, n+1);
  MultHuge(s_1, N1, X);
  AtribHuge(numitor, X);
  AtribValue(X, 1);
  Add1(numitor, X);
  DivideHuge(L1[n+2], numitor, K, R);
  WriteHuge(K);
End;

Begin
  Assign(Fout, 'ship.out'); ReWrite(Fout);
  Citire;
{  s := 6;  }
{  For n := 1 To 30 Do } {pentru s=2 fara numere mari merge pana la n=16}
    Begin              {pentru s=3 fara numere mari merge pana la n=12}
      Pascal;          {pentru s=4 fara numere mari merge pana la n=9}
      Calcul;
    End;               {pentru s=10 fara numere mari merge pana la n=6}
  close(Fout);
End.
